/*
 * TV-Browser
 * Copyright (C) 04-2003 Martin Oberhauser (darras@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * CVS information:
 *  $RCSfile: TvDataBaseListener.java,v $
 *   $Source: /cvsroot/tvbrowser/tvbrowser/src/tvbrowser/core/TvDataBaseListener.java,v $
 *     $Date: 2004/02/12 14:22:31 $
 *   $Author: til132 $
 * $Revision: 1.2 $
 */
package tvbrowser.core;

import devplugin.ChannelDayProgram;

/**
 * A listener that listens for TV data events  
 * 
 * @author Til Schneider, www.murfman.de
 */
public interface TvDataBaseListener {

  /**
   * Is called when a day program has been added to the TV data base.
   * 
   * @param prog The added day program.
   */
  public void dayProgramAdded(ChannelDayProgram prog);

  /**
   * Is called when a day program has been deleted from the TV data base.
   * 
   * @param prog The deleted day program.
   */
  public void dayProgramDeleted(ChannelDayProgram prog);

}
