/*
 * TV-Browser
 * Copyright (C) 04-2003 Martin Oberhauser (darras@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * CVS information:
 *  $RCSfile: ParserException.java,v $
 *   $Source: /cvsroot/tvbrowser/tvbrowser/src/tvbrowser/core/filters/ParserException.java,v $
 *     $Date: 2004/04/03 10:02:28 $
 *   $Author: darras $
 * $Revision: 1.1 $
 */

package tvbrowser.core.filters;

public class ParserException extends Exception {
 
    private int mPos;
    private String mMsg;
 
    public ParserException(int pos, String msg) {
        super(msg);   
        mPos=pos;
        mMsg=msg; 
    }
    
    public ParserException(String msg) {
        super(msg);
        mMsg=msg;
        mPos=-1;  
    }
    
    public int getPos() {
        return mPos;
    }
    
    public String getMessage() {
      if (mPos==-1) {
        return mMsg;
      }
      return "column "+mPos+": "+mMsg;
    }
    
    
}