/*
 * TV-Browser
 * Copyright (C) 04-2003 Martin Oberhauser (darras@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * CVS information:
 *  $RCSfile: MenuHelpTextAdapter.java,v $
 *   $Source: /cvsroot/tvbrowser/tvbrowser/src/tvbrowser/ui/mainframe/MenuHelpTextAdapter.java,v $
 *     $Date: 2003/08/13 20:21:26 $
 *   $Author: darras $
 * $Revision: 1.1 $
 */

package tvbrowser.ui.mainframe;

import javax.swing.*;
import javax.swing.event.*;

public class MenuHelpTextAdapter implements ChangeListener {
  
  private JMenuItem mMenuItem; 
  private String mHelpText;
  private JLabel mStatusBar; 

  public MenuHelpTextAdapter(JMenuItem menuItem, String helpText, JLabel statusBar) { 
    mMenuItem = menuItem; 
    mHelpText = helpText; 
    mStatusBar = statusBar; 
    mMenuItem.addChangeListener(this); 
  } 

  public void stateChanged(ChangeEvent evt) { 
    if (mMenuItem.isArmed()) 
      mStatusBar.setText(mHelpText); 
    else 
      mStatusBar.setText(" "); 
  } 

}
