/*
 * TV-Browser
 * Copyright (C) 04-2003 Martin Oberhauser (darras@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * CVS information:
 *  $RCSfile: AbstractSoftwareUpdateItem.java,v $
 *   $Source: /cvsroot/tvbrowser/tvbrowser/src/tvbrowser/ui/update/AbstractSoftwareUpdateItem.java,v $
 *     $Date: 2004/01/01 19:01:10 $
 *   $Author: darras $
 * $Revision: 1.1 $
 */


package tvbrowser.ui.update;

import util.exc.TvBrowserException;
import devplugin.Version;

abstract public class AbstractSoftwareUpdateItem implements SoftwareUpdateItem {
	
	protected Version mVersion, mRequiredVersion;
	protected String mName, mUrl, mDescription;
	
	protected AbstractSoftwareUpdateItem(String name) {
		setName(name);
	}
	
	public void setName(String name) {
		mName=name;
	}
	
	public String getName() {
		return mName;
	}
	
	public void setVersion(Version v) {
		mVersion=v;		
	}
	
	public void setRequiredVersion(Version v) {
		mRequiredVersion=v;
	}
	
	public Version getVersion() {
		return mVersion;
	}
	
	public Version getRequiredVerion() {
		return mRequiredVersion;
	}
	
	public void setUrl(String url) {
		mUrl=url;
	}
	
	public String getUrl() {
		return mUrl;
	}
	
	public void setDescription(String desc) {
		mDescription=desc;
	}
	
	public String getDescription() {
		return mDescription;
	}
	
	abstract public boolean download() throws TvBrowserException;
  
	
}